// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rcgcrd_spl_4:msg/RCGCRD.idl
// generated code does not contain a copyright notice

#ifndef RCGCRD_SPL_4__MSG__DETAIL__RCGCRD__FUNCTIONS_H_
#define RCGCRD_SPL_4__MSG__DETAIL__RCGCRD__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "rcgcrd_spl_4/msg/rosidl_generator_c__visibility_control.h"

#include "rcgcrd_spl_4/msg/detail/rcgcrd__struct.h"

/// Initialize msg/RCGCRD message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rcgcrd_spl_4__msg__RCGCRD
 * )) before or use
 * rcgcrd_spl_4__msg__RCGCRD__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
bool
rcgcrd_spl_4__msg__RCGCRD__init(rcgcrd_spl_4__msg__RCGCRD * msg);

/// Finalize msg/RCGCRD message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
void
rcgcrd_spl_4__msg__RCGCRD__fini(rcgcrd_spl_4__msg__RCGCRD * msg);

/// Create msg/RCGCRD message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rcgcrd_spl_4__msg__RCGCRD__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
rcgcrd_spl_4__msg__RCGCRD *
rcgcrd_spl_4__msg__RCGCRD__create();

/// Destroy msg/RCGCRD message.
/**
 * It calls
 * rcgcrd_spl_4__msg__RCGCRD__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
void
rcgcrd_spl_4__msg__RCGCRD__destroy(rcgcrd_spl_4__msg__RCGCRD * msg);

/// Check for msg/RCGCRD message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
bool
rcgcrd_spl_4__msg__RCGCRD__are_equal(const rcgcrd_spl_4__msg__RCGCRD * lhs, const rcgcrd_spl_4__msg__RCGCRD * rhs);

/// Copy a msg/RCGCRD message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
bool
rcgcrd_spl_4__msg__RCGCRD__copy(
  const rcgcrd_spl_4__msg__RCGCRD * input,
  rcgcrd_spl_4__msg__RCGCRD * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
const rosidl_type_hash_t *
rcgcrd_spl_4__msg__RCGCRD__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
const rosidl_runtime_c__type_description__TypeDescription *
rcgcrd_spl_4__msg__RCGCRD__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
const rosidl_runtime_c__type_description__TypeSource *
rcgcrd_spl_4__msg__RCGCRD__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
const rosidl_runtime_c__type_description__TypeSource__Sequence *
rcgcrd_spl_4__msg__RCGCRD__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/RCGCRD messages.
/**
 * It allocates the memory for the number of elements and calls
 * rcgcrd_spl_4__msg__RCGCRD__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
bool
rcgcrd_spl_4__msg__RCGCRD__Sequence__init(rcgcrd_spl_4__msg__RCGCRD__Sequence * array, size_t size);

/// Finalize array of msg/RCGCRD messages.
/**
 * It calls
 * rcgcrd_spl_4__msg__RCGCRD__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
void
rcgcrd_spl_4__msg__RCGCRD__Sequence__fini(rcgcrd_spl_4__msg__RCGCRD__Sequence * array);

/// Create array of msg/RCGCRD messages.
/**
 * It allocates the memory for the array and calls
 * rcgcrd_spl_4__msg__RCGCRD__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
rcgcrd_spl_4__msg__RCGCRD__Sequence *
rcgcrd_spl_4__msg__RCGCRD__Sequence__create(size_t size);

/// Destroy array of msg/RCGCRD messages.
/**
 * It calls
 * rcgcrd_spl_4__msg__RCGCRD__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
void
rcgcrd_spl_4__msg__RCGCRD__Sequence__destroy(rcgcrd_spl_4__msg__RCGCRD__Sequence * array);

/// Check for msg/RCGCRD message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
bool
rcgcrd_spl_4__msg__RCGCRD__Sequence__are_equal(const rcgcrd_spl_4__msg__RCGCRD__Sequence * lhs, const rcgcrd_spl_4__msg__RCGCRD__Sequence * rhs);

/// Copy an array of msg/RCGCRD messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcrd_spl_4
bool
rcgcrd_spl_4__msg__RCGCRD__Sequence__copy(
  const rcgcrd_spl_4__msg__RCGCRD__Sequence * input,
  rcgcrd_spl_4__msg__RCGCRD__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // RCGCRD_SPL_4__MSG__DETAIL__RCGCRD__FUNCTIONS_H_
